unit todomain;

interface

uses
  SysUtils, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QComCtrls, QMenus, input, QExtCtrls, version, QImgList,
  delete_confirm, over_confirm, exit_confirm, suzutalk, QTypes;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    N14: TMenuItem;
    N15: TMenuItem;
    N16: TMenuItem;
    List: TListView;
    N17: TMenuItem;
    BackCG: TImage;
    ImageButton1: TImage;
    ImageButton2: TImage;
    Obj1: TImage;
    Obj2: TImage;
    Sync: TTimer;
    SuzuTalk: TLabel;
    ImageButtonList: TImageList;
    DispTime: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure NewEntryRequest(Sender: TObject);
    procedure N12Click(Sender: TObject);
    procedure N13Click(Sender: TObject);
    procedure N8Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure IDoItClick(Sender: TObject);
    procedure N10Click(Sender: TObject);
    procedure N11Click(Sender: TObject);
    procedure ListCompare(Sender: TObject; Item1, Item2: TListItem;
      Data: Integer; var Compare: Integer);
    procedure N16Click(Sender: TObject);
    procedure N15Click(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure ListColumnClick(Sender: TObject; Column: TListColumn);
    procedure N4Click(Sender: TObject);
    procedure CGAreaPaint(Sender: TObject);
    procedure ImageButton1Down(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImageButton1Up(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImageButton2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImageButton2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SyncTimer(Sender: TObject);
    procedure SuzuRequest(num : Integer);
  private
    {===== ̤ǡɽƤ뤫 =====}
    ListDispFlag : Boolean;
    {===== ꥹɽκݤΥȼ =====}
    ListSortFlag : Integer;
    {===== ToDoǡݻꥹȥ饹 =====}
    ToDoItem : TList;
    {===== طʥեå饹 =====}
    Screen : TBitmap;
    SuzuObj1 : TBitmap;
    SuzuObj2 : TBitmap;
    {===== Υ󥯥饹 =====}
    Suzu : TSuzuTalk;
    ChatTime : Integer;
    {-- ǡ}
    procedure AddNewToDo;
    procedure EditToDo(data : Pointer);
    procedure DelToDo(data : Pointer);
    procedure DelDoneToDo;
    procedure DelAllToDo;
    procedure SortToDo;
    procedure PackToDo;
    {-- ꥹɽ}
    procedure ListAfter;
    procedure ListBefore;
    procedure ListSort;
    {-- ե}
    procedure SaveData;
    procedure LoadData;
    {-- }
    procedure Execute(prog: String);
    procedure GetToDoData(tag: String; ptr: Pointer);
    function  NextParts(var DataString: String): String;
    function  TagArgc(tag, sep: String): Integer;
    function  TagParts(var tag: String; sep: String): String;
    function  TagAreaGet(var tag: String; jump: String): String;
  public
    { Public  }
  end;


  {===== ToDoǡΤι¤ =====}
type
  PToDo = ^RToDo;
  RToDo = record
    Memo : String;
    EndFlag : boolean;
    Priority : Integer;
    TargetDate : TDateTime;
    EndDate : TDateTime;
  end;

  {===== ̤ͥɽʸ =====}
const
  TxtPriority : array[0..2] of String = (
                   '⤤', '', '㤤');
  DataName = 'SUZUTODO.DAT';
  MonthNames : array [0..11] of String = ('Jan', 'Feb', 'Mar', 'Apr',
                                          'May', 'Jun', 'Jul', 'Aug',
                                          'Sep', 'Oct', 'Nov', 'Dec');

var
  {--- ɽΥߥ󥰥ե饰}
  Posttime : Word;
  Form1: TForm1;
  {===== ToDoӴؿ =====}
  function CompareToDo(dat1, dat2 : Pointer) : Integer;


implementation

{$R *.xfm}

{$UNDEF SJIS}


{------------------------------------------------------}
{======= ưλ ===============================}
{------------------------------------------------------}

{===== ư }
procedure TForm1.FormCreate(Sender: TObject);
var
  p : PToDo;
  num, i : Integer;
  Dlog : TOverConfirm;
begin
  {--- ư¾ ---}
  ToDoItem := TList.Create;
  ListDispFlag := True;
  ListSortFlag := 0;
  Randomize;
  {--- եå rrpixel ذư ---}
  TBitMap(BackCG.Picture.Graphic).PixelFormat := pf32bit;
  TBitMap(Obj1.Picture.Graphic).PixelFormat := pf32bit;
  TBitMap(Obj2.Picture.Graphic).PixelFormat := pf32bit;
  Screen := TBitmap.Create;
  Screen.Assign(BackCG.Picture.Graphic);
  SuzuObj1 := TBitmap.Create;
  SuzuObj1.Assign(Obj1.Picture.Graphic);
  SuzuObj2 := TBitmap.Create;
  SuzuObj2.Assign(Obj2.Picture.Graphic);
  BackCG.Free;
  Obj1.Free;
  Obj2.Free;
//  Form1.DoubleBuffered := True;
  {--- ν ---}
  Suzu := TSuzuTalk.Create;
  Suzu.SetClass(Screen, SuzuObj1, SuzuObj2, SuzuTalk);
  ChatTime := 1200; {2ʬۤ}
  PostTime := 99;
  {--- եåܥ ---}
//  ImageButtonList.GetBitmap(0, ImageButton1.Picture.Bitmap);
//  ImageButtonList.GetBitmap(2, ImageButton2.Picture.Bitmap);
  {--- ǯǡեޥå}
  ShortdateFormat := 'yyyy/mm/dd';
  {--- ToDoǡɤ߹ ---}
  LoadData;
  {--- ɽ}
  ListBefore;
  {--- ڤå}
  num := 0;
  for i := 0 to ToDoItem.Count-1 do
  begin
    p := ToDoItem.Items[i];
    if (p^.TargetDate < Date) and (p^.EndFlag = False) then Inc(num);
  end;
  if num > 0 then
  begin
    {-- ڤ줬}
    Dlog := TOverConfirm.Create(Self);
    Dlog.ConfirmMes(num);
    Dlog.ShowModal;
    Dlog.Free;
  end;
end;

{===== λ }
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  {--- λγǧ ---}
  {--- λΥ֤ʤ ---}
  SaveData;
  {--- ¾λ ---}
  DelAllToDo;
  ToDoItem.Free;
  Screen.Free;
  SuzuObj1.Free;
  SuzuObj2.Free;
end;



{------------------------------------------------------}
{======= ToDo ǡδʬ ========================}
{------------------------------------------------------}

{===== ToDoǡ }
procedure TForm1.AddNewToDo;
var
  NewData : PTodo;
  DataIn : TDataInput;
begin
  {--- ǡ }
  New(NewData);
  NewData^.Memo := '';
  NewData^.EndFlag := False;
  NewData^.Priority := 1;
  NewData^.TargetDate := Date;
  NewData^.EndDate := Date;
  {--- ϥ }
  DataIn := TDataInput.Create(Self);
  DataIn.Memo := NewData^.Memo;
  DataIn.EndFlag := NewData^.EndFlag;
  DataIn.Priority := NewData^.Priority;
  DataIn.TargetDate := NewData^.TargetDate;
  DataIn.EndDate := NewData^.EndDate;
  DataIn.ShowModal;
  if DataIn.ModalResult = mrOK then
  begin
    NewData^.Memo := DataIn.Memo;
    NewData^.EndFlag := DataIn.EndFlag;
    NewData^.Priority := DataIn.Priority;
    NewData^.TargetDate := DataIn.TargetDate;
    NewData^.EndDate := DataIn.EndDate;
    {--- List }
    ToDoItem.Add(NewData);
  end;
  DataIn.Free;
end;

{===== ToDoǡ }
procedure TForm1.EditToDo(data : Pointer);
var
  DataIn : TDataInput;
begin
  {--- ϥ }
  DataIn := TDataInput.Create(Self);
  DataIn.Memo := PTodo(data)^.Memo;
  DataIn.EndFlag := PTodo(data)^.EndFlag;
  DataIn.Priority := PTodo(data)^.Priority;
  DataIn.TargetDate := PTodo(data)^.TargetDate;
  DataIn.EndDate := PTodo(data)^.EndDate;
  DataIn.ShowModal;
  if DataIn.ModalResult = mrOK then
  begin
    PTodo(data)^.Memo := DataIn.Memo;
    PTodo(data)^.EndFlag := DataIn.EndFlag;
    PTodo(data)^.Priority := DataIn.Priority;
    PTodo(data)^.TargetDate := DataIn.TargetDate;
    PTodo(data)^.EndDate := DataIn.EndDate;
  end;
  DataIn.Free;
end;

{===== ToDoǡ }
procedure TForm1.DelToDo(data : Pointer);
var
  i : Integer;
begin
  {--- ꥹȤ }
  i := ToDoItem.IndexOf(data);
  ToDoItem.Items[i] := nil;
  {--- 夫 }
  Dispose(data);
end;

{===== ȺѤߥǡ }
procedure TForm1.DelDoneToDo;
var
  Data : PTodo;
  i : Integer;
begin
  for i := 0 to (ToDoItem.Count - 1) do
  begin
    if ToDoItem.Items[i] <> nil then
    begin
      Data := ToDoItem.Items[i];
      if Data^.EndFlag = True then DelTodo(Data);
    end;
  end;
end;

{===== ǡ }
procedure TForm1.DelAllToDo;
var
  Data : PTodo;
  i : Integer;
begin
  for i := 0 to (ToDoItem.Count - 1) do
  begin
    if ToDoItem.Items[i] <> nil then
    begin
      Data := ToDoItem.Items[i];
      DelTodo(Data);
    end;
  end;
end;

{===== ToDoǡδ }
procedure TForm1.SortToDo;
var
  ListCompare : TListSortCompare;
begin
  ListCompare := CompareToDo;
  ToDoItem.Sort(ListCompare);
end;

{===== Ѵؿ 1}
function CompareToDo(dat1, dat2 : Pointer) : Integer;
begin
  Result := Trunc(RTodo(dat1^).TargetDate - RTodo(dat2^).TargetDate);
end;
{===== Ѵؿ 2}
function CompareToDo2(dat1, dat2 : Pointer) : Integer;
begin
  Result := Trunc(RTodo(dat1^).EndDate - RTodo(dat2^).EndDate);
end;
{===== Ѵؿ 3}
function CompareToDo3(dat1, dat2 : Pointer) : Integer;
begin
  Result := Trunc(RTodo(dat1^).Priority - RTodo(dat2^).Priority);
end;


{===== ToDoǡΥѥå(ľ) }
procedure TForm1.PackToDo;
begin
  ToDoItem.Pack;
  SortToDo;
end;


{------------------------------------------------------}
{======= ToDo ꥹȤɽʬ ========================}
{------------------------------------------------------}

{===== ̤ꥹȤȤƿɽ }
procedure TForm1.ListBefore;
var
  p : PToDo;
  i, n : Integer;
begin
  {--- ɽ}
  List.Columns.BeginUpdate;
  {--- κϿ}
  List.Columns.Clear;
  n := 0;
  try
    List.Columns.Add;
    List.Columns.Items[n].Caption := '椦';
    List.Columns.Items[n].AutoSize := False;
    List.Columns.Items[n].Alignment := taCenter;
//    List.Columns.Items[n].Width := ColumnHeaderWidth;
    List.Columns.Items[n].Width := -2;
    List.Columns.Items[n].MinWidth := 64;
    Inc(n);
    List.Columns.Add;
    List.Columns.Items[n].Caption := '';
    List.Columns.Items[n].AutoSize := True;
    List.Columns.Items[n].Alignment := taCenter;
//    List.Columns.Items[n].Width := ColumnTextWidth;
    List.Columns.Items[n].Width := -1;
    List.Columns.Items[n].MinWidth := 80;
    Inc(n);
    List.Columns.Add;
    List.Columns.Items[n].Caption := '뤳';
    List.Columns.Items[n].AutoSize := True;
    List.Columns.Items[n].Alignment := taLeftJustify;
//    List.Columns.Items[n].Width := ColumnTextWidth;
    List.Columns.Items[n].Width := -1;
    List.Columns.Items[n].MinWidth := 160;
  finally
    {--- ɽƳ}
    List.Columns.EndUpdate;
  end;
  {--- ꥹɽ}
  List.Items.BeginUpdate;
  {--- ꥹȤκϿ}
  List.Items.Clear;
  n := 0;
  try
    { ꥹȺϿ}
    for i := 0 to (ToDoItem.Count - 1) do
    begin
      p := ToDoItem.Items[i];
      if p <> nil then
      begin
        if p^.EndFlag = False then
        begin
          {Ͽ}
          List.Items.Add;
          List.Items.Item[n].Caption := TxtPriority[p^.Priority];
          List.Items.Item[n].SubItems.Add(DateToStr(p^.TargetDate));
          List.Items.Item[n].SubItems.Add(p^.Memo);
          List.Items.Item[n].Data := p;
          Inc(n);
        end;
      end;
    end;
  finally
    {--- ꥹɽƳ}
    List.Items.EndUpdate;
  end;
end;

{===== ѥꥹȤȤƿɽ }
procedure TForm1.ListAfter;
var
  p : PToDo;
  i, n : Integer;
begin
  {--- ɽ}
  List.Columns.BeginUpdate;
  {--- κϿ}
  List.Columns.Clear;
  n := 0;
  try
    List.Columns.Add;
    List.Columns.Items[n].Caption := 'ä';
    List.Columns.Items[n].AutoSize := True;
    List.Columns.Items[n].Alignment := taCenter;
//    List.Columns.Items[n].Width := ColumnHeaderWidth;
    List.Columns.Items[n].Width := -2;
    List.Columns.Items[n].MinWidth := 80;
    Inc(n);
    List.Columns.Add;
    List.Columns.Items[n].Caption := '椦';
    List.Columns.Items[n].AutoSize := False;
    List.Columns.Items[n].Alignment := taCenter;
//    List.Columns.Items[n].Width := ColumnHeaderWidth;
    List.Columns.Items[n].Width := -2;
    List.Columns.Items[n].MinWidth := 64;
    Inc(n);
    List.Columns.Add;
    List.Columns.Items[n].Caption := 'ä';
    List.Columns.Items[n].AutoSize := True;
    List.Columns.Items[n].Alignment := taLeftJustify;
//    List.Columns.Items[n].Width := ColumnTextWidth;
    List.Columns.Items[n].Width := -1;
    List.Columns.Items[n].MinWidth := 160;
  finally
    {--- ɽƳ}
    List.Columns.EndUpdate;
  end;
  {--- ꥹɽ}
  List.Items.BeginUpdate;
  {--- ꥹȤκϿ}
  List.Items.Clear;
  n := 0;
  try
    { ꥹȺϿ}
    for i := 0 to (ToDoItem.Count - 1) do
    begin
      p := ToDoItem.Items[i];
      if p <> nil then
      begin
        if p^.EndFlag = True then
        begin
          {Ͽ}
          List.Items.Add;
          List.Items.Item[n].Caption := DateToStr(p^.EndDate);
          List.Items.Item[n].SubItems.Add(TxtPriority[p^.Priority]);
          List.Items.Item[n].SubItems.Add(p^.Memo);
          List.Items.Item[n].Data := p;
          Inc(n);
        end;
      end;
    end;
  finally
    {--- ꥹɽƳ}
    List.Items.EndUpdate;
  end;
end;

{===== ꥹɽȴؿ (Windows) }
procedure TForm1.ListCompare(Sender: TObject; Item1, Item2: TListItem;
  Data: Integer; var Compare: Integer);
var
  p1, p2 : PToDo;
begin
  p1 := Item1.Data;
  p2 := Item2.Data;
  {--- ˱}
  if (ListDispFlag = True) and (ListSortFlag = 0) then
  begin
    Compare := Trunc(p1^.TargetDate - p2^.TargetDate);
  end;
  if (ListDispFlag = True) and (ListSortFlag = 1) then
  begin
    Compare := p1^.Priority - p2^.Priority;
  end;
  if (ListDispFlag = False) and (ListSortFlag = 0) then
  begin
    Compare := Trunc(p2^.EndDate - p1^.EndDate);
  end;
  if (ListDispFlag = False) and (ListSortFlag = 1) then
  begin
    Compare := p1^.Priority - p2^.Priority;
  end;
end;

{===== KylixѼ(ʰ) }
procedure TForm1.ListSort;
var
  ListCompare : TListSortCompare;
begin
  {--- ˱}
  ListCompare := CompareToDo;
  if (ListDispFlag = True) and (ListSortFlag = 0) then
  begin
    ListCompare := CompareToDo;
  end;
  if (ListDispFlag = True) and (ListSortFlag = 1) then
  begin
    ListCompare := CompareToDo3;
  end;
  if (ListDispFlag = False) and (ListSortFlag = 0) then
  begin
    ListCompare := CompareToDo2;
  end;
  if (ListDispFlag = False) and (ListSortFlag = 1) then
  begin
    ListCompare := CompareToDo3;
  end;
  { -- SORT }
  ToDoItem.Sort(ListCompare);
  {-- ɽ}
  if ListDispFlag = True then ListBefore
  else ListAfter;
end;


{------------------------------------------------------}
{======= 饯ɽʬ =====================}
{------------------------------------------------------}

{===== ޡ }
procedure TForm1.SyncTimer(Sender: TObject);
var
  t1, t2, t3, t4 : Word;
  Dtxt, Ttxt : String;
begin
  if Suzu.ScriptFlag = True then
  begin
    {--- 󥹤ä¹}
    Suzu.Main;
    {--- եåեå׵}
    if Suzu.RefreshFlag = True then
    begin
      Refresh;
      Suzu.RefreshFlag := False;
    end;
    {--- ¤ϽλäȤ⡼ɤλŹ}
    if Suzu.ScriptFlag = False then
    begin
      ChatTime := 1200 + Trunc(Random(1800));
    end;
  end
  else
  begin
    {--- 󥹤̵֤ʤɽ}
    if DispTime.Visible = False then
    begin
      DispTime.Visible := True;
      SuzuTalk.Visible := False;
    end;
    DecodeTime(Now, t1, t2, t3, t4);
    if Posttime <> t2 then
    begin
      Posttime := t2;
      if DispTime.Visible = False then DispTime.Visible := True;
      SuzuTalk.Visible := False;
      DecodeDate(Now, t1, t2, t3);
      Dtxt := MonthNames[t2-1]+FormatDateTime('"."d"."yyyy', Now);
      Ttxt := FormatDateTime('h":"nn', Now);
      DispTime.Caption := Dtxt+'  '+Ttxt;
    end;
    {--- Ȥ⡼ɤΥߥ󥰥}
    if ChatTime > 0 then Dec(ChatTime)
    else
    begin
      SuzuRequest(3+Trunc(Random(7)));
    end;
  end;
end;

{===== Υꥯ }
procedure TForm1.SuzuRequest(num : Integer);
begin
  Suzu.StartScript(num);
  DispTime.Visible := False;
  SuzuTalk.Visible := True;
end;


{------------------------------------------------------}
{======= եʬ ===========================}
{------------------------------------------------------}

{===== ֽ }
procedure TForm1.SaveData;
var
  fp : TextFile;
  tmp : String;
  p : PToDo;
  i : Integer;
  rep : TReplaceFlags;
begin
  {--- ǡ}
  PackToDo;
  {--- ե륪ץ}
  AssignFile(fp, ExtractFilePath(Application.EXEName)+DataName);
  Rewrite(fp);
  {--- ǡ}
  WriteLn(fp, '<todo>');
  for i := 0 to ToDoItem.Count-1 do
  begin
    p := ToDoItem.Items[i];
    WriteLn(fp, '<job>');
    {-- λ}
    if p^.EndFlag = True then WriteLn(fp, '<done>');
    {-- ͥ}
    case p^.Priority of
      0 : WriteLn(fp, '<hurry>');
      1 : WriteLn(fp, '<medium>');
      2 : WriteLn(fp, '<quite>');
    end;
    {-- }
    tmp := '<term '+DateToStr(p^.TargetDate)+'>';
    WriteLn(fp, tmp);
    {-- λ}
    tmp := '<end '+DateToStr(p^.EndDate)+'>';
    WriteLn(fp, tmp);
    {-- }
    rep := [rfReplaceAll];
    tmp := p^.Memo;
    tmp := StringReplace(tmp, '>', '', rep);
    tmp := StringReplace(tmp, '<', '', rep);
    WriteLn(fp, '<memo>');
    WriteLn(fp, tmp);
    WriteLn(fp, '</memo>');
    WriteLn(fp, '</job>');
    WriteLn(fp);
  end;
  WriteLn(fp, '</todo>');
  {--- ե륯}
  CloseFile(fp);
end;

{===== ɽ }
procedure TForm1.LoadData;
var
  Input: TextFile;
  GetLine, Data, Body, bit, tag: String;
begin
  if FileExists(ExtractFilePath(Application.EXEName)+DataName) = False then exit;
  AssignFile(Input, ExtractFilePath(Application.EXEName)+DataName);
  reset(Input);
  Data := '';
  while not EOF(Input) do begin
    ReadLn(Input, GetLine);
    GetLine := Trim(GetLine);
    Data := Data + GetLine;
  end;
  CloseFile(Input);
  { ǡפ̤ʬ }
  while length(Data) > 0 do
  begin
    bit := NextParts(Data);
    if bit[1] = '<' then
    begin
      tag := TagParts(bit, ' ');
      if tag = 'todo' then
      begin
        { event ֥ȤȤϤ }
        Body := TagAreaGet(Data, 'todo');
        Execute(Body);
      end;
    end
  end;
end;


{=== ե뤬¸ߤ True ֤ؿ}
function FileExists(FileName: string): Boolean;
var
  F: file;
begin
  {$I-}
  AssignFile(F, FileName);
  FileMode := 0;  {ե⡼ɤɤ߼Ѥ }
  Reset(F);
  CloseFile(F);
  {$I+}
  FileExists := (IOResult = 0) and (FileName <> '');
end;  { FileExists }


{ --- եβϼ¹ }
procedure TForm1.Execute(prog: String);
var
  bit, arg, tag: String;
  job : PToDo;
begin
  { ǡĹʬ¹ }
  while length(prog) > 0 do
  begin
    bit := NextParts(prog);
    if bit[1] = '<' then
    begin
      tag := TagParts(bit, ' ');
      if tag = 'job' then
      begin
        {--- ToDoǡ }
        New(job);
        job^.Memo := '';
        job^.EndFlag := False;
        job^.Priority := 1;
        job^.TargetDate := Date;
        job^.EndDate := Date;
        arg := TagAreaGet(prog, 'job');
        GetToDoData(arg, job);
        {--- List }
        ToDoItem.Add(job);
       end;
    end;
    {ǤʤäڤΤƤޤ}
  end;
end;

procedure TForm1.GetToDoData(tag: String; ptr: Pointer);
var
  arg, param, bit: String;
  p : PToDo;
begin
  p := ptr;
  { ǡĹʬ¹ }
  while length(tag) > 0 do
  begin
    bit := NextParts(tag);
    if bit[1] = '<' then
    begin
      arg := TagParts(bit, ' ');
      {ȴ}
      if arg = 'term' then
      begin
        if TagArgc(bit, ' ') > 0 then
        begin
          param := TagParts(bit, ' ');
          p^.TargetDate := StrToDate(param);
        end;
      end;
      {λ}
      if arg = 'end' then
      begin
        if TagArgc(bit, ' ') > 0 then
        begin
          param := TagParts(bit, ' ');
          p^.EndDate := StrToDate(param);
        end;
      end;
      {}
      if arg = 'memo' then
      begin
        param := TagAreaGet(tag, 'memo');
        p^.Memo := param;
      end;
      {λѥե饰}
      if arg = 'done' then
      begin
        p^.EndFlag := True;
      end;
      {}
      if arg = 'hurry' then
      begin
        p^.Priority := 0;
      end;
      {դĤ}
      if arg = 'medium' then
      begin
        p^.Priority := 1;
      end;
      {Ƥʤ}
      if arg = 'quite' then
      begin
        p^.Priority := 2;
      end;
    end;
    {ǤʤΤ̵}
  end;
end;


{===== ط }
{ --- ꥿ϰϤФ }
function TForm1.TagAreaGet(var tag: String; jump: String): String;
var retbuf, endtag, tmp: String;
var nest: Integer;
begin
  nest := 0;
  tmp := jump;
  endtag := TagParts(tmp, ' ');
  endtag := '/' + endtag;
  retbuf := '';
  while length(tag) > 0 do
  begin
    tmp := NextParts(tag);
    if (tmp[1] = '<') and (pos(endtag, tmp) > 0) then
      if nest = 0 then break
      else
        nest := nest -  1
    else
    if pos(jump, tmp) > 0 then
      nest := nest + 1;
    retbuf := retbuf + tmp;
  end;
  TagAreaGet := retbuf;
end;

{ ---  argmrnt 夲 }
function  TForm1.TagArgc(tag, sep: String): Integer;
var  i, l, c: Integer;
var  post: String;
begin
  l := Length(tag);
  post := sep;
  if l > 0 then c := 1
  else begin
    TagArgc := 0;
    exit;
  end;
  for i := 1 to l do
  begin
    if tag[i] = sep then
    begin
      if post <> sep then
        c := c + 1;
    end;
    post := tag[i];
  end;
  TagArgc := c;
end;

{ ---  1arg Ф }
function  TForm1.TagParts(var tag: String; sep: String): String;
var  l: Integer;
var  ret, post: String;
var  chr: Byte;
begin
  l := Length(tag);
  if tag[l] = '>' then
  begin
    Delete(tag, l, 1);
  end;
  if tag[1] = '<' then
  begin
    Delete(tag, 1, 1);
  end;
  post := sep;
  ret := '';
  while length(tag) > 0 do
  begin
    if tag[1] = sep then
      if post = sep then
      begin
        Delete(tag, 1, 1);
        continue;
      end
      else break;
    chr := byte(tag[1]);
    post := tag[1];
{$IFDEF SJIS}
    if ((chr > $80) and (chr < $a0)) or
    ((chr > $df) and (chr < $f0)) then
{$ELSE}
    if (chr > $a0) and (chr <= $fe) then
{$ENDIF}
    begin
      ret := ret + tag[1] + tag[2];
      Delete(tag, 1, 2);
    end
    else
    begin
      ret := ret + tag[1];
      Delete(tag, 1, 1);
    end;
  end;
  Delete(tag, 1, 1);
  TagParts := ret;
end;

{ --- ǡ򥿥Ȥ¾ʬ1Ĥ֤ }
function  TForm1.NextParts(var DataString: String): String;
var retbuf: String;
var chr: Byte;
begin
  DataString := Trim(DataString);
  chr := byte(DataString[1]);
  if chr = Byte('<') then
  begin
    { Ф }
    retbuf := DataString[1];
    Delete(DataString, 1, 1);
    while length(DataString) > 0 do
    begin
      chr := byte(DataString[1]);
{$IFDEF SJIS}
      if ((chr > $80) and (chr < $a0)) or
          ((chr > $df) and (chr < $f0)) then
{$ELSE}
      if (chr > $a0) and (chr <= $fe) then
{$ENDIF}
      begin
        retbuf := retbuf + DataString[1] + DataString[2];
        Delete(DataString, 1, 2);
      end
      else begin
        retbuf := retbuf + AnsiLowerCase(DataString[1]);
        Delete(DataString, 1, 1);
        if chr = Byte('>') then break;
      end;
    end;
  end
  else begin
    { ʳξ󤭤Ф }
    Retbuf := '';
    while length(DataString) > 0 do
    begin
      chr := byte(DataString[1]);
{$IFDEF SJIS}
      if ((chr > $80) and (chr < $a0)) or
          ((chr > $df) and (chr < $f0)) then
{$ELSE}
      if (chr > $a0) and (chr <= $fe) then
{$ENDIF}
      begin
        retbuf := retbuf + DataString[1] + DataString[2];
        Delete(DataString, 1, 2);
      end
      else begin
        if chr = Byte('<') then break;
        retbuf := retbuf + AnsiLowerCase(DataString[1]);
        Delete(DataString, 1, 1);
      end;
    end;
  end;
  retbuf := Trim(retbuf);
  NextParts := retbuf;
end;


{------------------------------------------------------}
{======= եåܥʤ =======================}
{------------------------------------------------------}
procedure TForm1.ImageButton1Down(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ImageButtonList.GetBitmap(1, ImageButton1.Picture.Bitmap);
  ImageButton1.Repaint;
end;

procedure TForm1.ImageButton1Up(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ImageButtonList.GetBitmap(0, ImageButton1.Picture.Bitmap);
  ImageButton1.Repaint;
end;

procedure TForm1.ImageButton2MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ImageButtonList.GetBitmap(3, ImageButton2.Picture.Bitmap);
  ImageButton2.Repaint;
end;

procedure TForm1.ImageButton2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ImageButtonList.GetBitmap(2, ImageButton2.Picture.Bitmap);
  ImageButton2.Repaint;
end;

{------------------------------------------------------}
{======= 桼󥿡եʬ =================}
{------------------------------------------------------}

{===== λ }
procedure TForm1.N6Click(Sender: TObject);
begin
  Close;
end;

{===== ˺Ͽ }
procedure TForm1.NewEntryRequest(Sender: TObject);
begin
  {-- }
  AddNewToDo;
  {-- ɽ}
  if ListDispFlag = True then ListBefore
  else ListAfter;
  SuzuRequest(0);
end;

{===== ̤Ȥɽ }
procedure TForm1.N12Click(Sender: TObject);
begin
  ListDispFlag := True;
  ListBefore;
end;

{===== ѺȤɽ }
procedure TForm1.N13Click(Sender: TObject);
begin
  ListDispFlag := False;
  ListAfter;
end;

{===== Ͽѥǡν }
procedure TForm1.N8Click(Sender: TObject);
begin
  if List.SelCount = 1 Then
  begin
    EditToDo(List.Items[List.Selected.Index].Data);
    {-- ɽ}
    if ListDispFlag = True then ListBefore
    else ListAfter;
  end;
end;

{===== ϿǡѤ˰ܹ }
procedure TForm1.IDoItClick(Sender: TObject);
var
  p : PToDo;
begin
  if List.SelCount = 1 Then
  begin
    p := List.Items[List.Selected.Index].Data;
    if p^.EndFlag = False then
    begin
      p^.EndFlag := True;
      p^.EndDate := Date;
      {-- ɽ}
      if ListDispFlag = True then ListBefore
      else ListAfter;
      SuzuRequest(1);
    end;
  end;
end;

{===== Ͽǡ1ĺ }
procedure TForm1.N10Click(Sender: TObject);
var
  dlog : TDConfirm;
begin
  if List.SelCount = 1 Then
  begin
    { ǧ }
    dlog := TDConfirm.Create(Self);
    dlog.Top := Form1.Top + 48;
    dlog.Left := Form1.Left + 64;
    dlog.ConfirmMes('򤵤줿ǡޤ');
    if dlog.ShowModal = mrOK then
    begin
      DelToDo(List.Items[List.Selected.Index].Data);
      List.Items.Delete(List.Selected.Index);
      SuzuRequest(2);
    end;
    dlog.Free;
  end;
end;

{===== ȺѤߥǡ }
procedure TForm1.N11Click(Sender: TObject);
var
  dlog : TDConfirm;
begin
  { ǧ }
  dlog := TDConfirm.Create(Self);
  dlog.Top := Form1.Top + 48;
  dlog.Left := Form1.Left + 64;
  dlog.ConfirmMes('ѤΥǡ򤹤٤ƺޤ');
  if dlog.ShowModal = mrOK then
  begin
    {-- }
    DelDoneToDo;
    {-- ɽ}
    if ListDispFlag = True then ListBefore
    else ListAfter;
    SuzuRequest(2);
  end;
  dlog.Free;
end;

{===== ȹܤλ }
procedure TForm1.N16Click(Sender: TObject);
begin
  {-- Ҥˤ}
  ListSortFlag := 0;
  N16.Checked := True;
//  List.CustomSort(nil, 1);
  ListSort;
end;
procedure TForm1.N15Click(Sender: TObject);
begin
  {-- }
  ListSortFlag := 1;
  N15.Checked := True;
//  List.CustomSort(nil, 1);
  ListSort;
end;

{===== ˥塼С饻 }
procedure TForm1.N5Click(Sender: TObject);
begin
  SaveData;
  {--- ֤ޤ}
end;

{===== С򲡤ƥ }
procedure TForm1.ListColumnClick(Sender: TObject; Column: TListColumn);
begin
  if Column.Caption = '椦' then
  begin
    ListSortFlag := 1;
    N15.Checked := True;
  end
  else
  begin
    ListSortFlag := 0;
    N16.Checked := True;
  end;
//  List.CustomSort(nil, 1);
  ListSort;
end;

{===== Сɽ }
procedure TForm1.N4Click(Sender: TObject);
var
  Version : TVersionPanel;
begin
  Version := TVersionPanel.Create(Self);
  Version.Top := Form1.Top + 48;
  Version.Left := Form1.Left + 64;
  Version.ShowModal;
  Version.Free;
end;

{===== طʥեåΥեå᥽å }
procedure TForm1.CGAreaPaint(Sender: TObject);
begin
  Form1.Canvas.Draw(0, 0, Screen);
  Form1.Canvas.Draw(ImageButton1.left, ImageButton1.Top,
                    ImageButton1.Picture.Graphic);
  Form1.Canvas.Draw(ImageButton2.left, ImageButton2.Top,
                    ImageButton2.Picture.Graphic);
end;

{===== λκݤγǧ }
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  dlog : TExitConfirm;
begin
  CanClose := False;
  dlog := TExitConfirm.Create(Self);
  dlog.Top := Form1.Top + 48;
  dlog.Left := Form1.Left + 64;
  if dlog.ShowModal = mrOk then CanClose := True;
  dlog.Free;
end;


end.
